Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.ode.nonstiff
Class DormandPrince853Integrator

    java.lang.Object
      org.apache.commons.math.ode.AbstractIntegrator
          org.apache.commons.math.ode.nonstiff.AdaptiveStepsizeIntegrator
              org.apache.commons.math.ode.nonstiff.EmbeddedRungeKuttaIntegrator
                  org.apache.commons.math.ode.nonstiff.DormandPrince853Integrator

All Implemented Interfaces:
  FirstOrderIntegrator, ODEIntegrator

    public class DormandPrince853Integrator

extends EmbeddedRungeKuttaIntegrator

This class implements the 8(5,3) Dormand-Prince integrator for Ordinary Differential Equations.

This integrator is an embedded Runge-Kutta integrator of order 8(5,3) used in local extrapolation mode (i.e. the solution is computed using the high order formula) with stepsize control (and automatic step initialization) and continuous output. This method uses 12 functions evaluations per step for integration and 4 evaluations for interpolation. However, since the first interpolation evaluation is the same as the first integration evaluation of the next step, we have included it in the integrator rather than in the interpolator and specified the method was an fsal. Hence, despite we have 13 stages here, the cost is really 12 evaluations per step even if no interpolation is done, and the overcost of interpolation is only 3 evaluations.

This method is based on an 8(6) method by Dormand and Prince (i.e. order 8 for the integration and order 6 for error estimation) modified by Hairer and Wanner to use a 5th order error estimator with 3rd order correction. This modification was introduced because the original method failed in some cases (wrong steps can be accepted when step size is too large, for example in the Brusselator problem) and also had severe difficulties when applied to problems with discontinuities. This modification is explained in the second edition of the first volume (Nonstiff Problems) of the reference book by Hairer, Norsett and Wanner: Solving Ordinary Differential Equations (Springer-Verlag, ISBN 3-540-56670-8).

Since:
  1.2
Version:
  $Revision: 810196 $ $Date: 2009-09-01 15:47:46 -0400 (Tue, 01 Sep 2009) $

Field Summary
`private static double` | `E1_01` First error weights array, element 1.
`private static double` | `E1_06` First error weights array, element 6.
`private static double` | `E1_07` First error weights array, element 7.
`private static double` | `E1_08` First error weights array, element 8.
`private static double` | `E1_09` First error weights array, element 9.
`private static double` | `E1_10` First error weights array, element 10.
`private static double` | `E1_11` First error weights array, element 11.
`private static double` | `E1_12` First error weights array, element 12.
`private static double` | `E2_01` Second error weights array, element 1.
`private static double` | `E2_06` Second error weights array, element 6.
`private static double` | `E2_07` Second error weights array, element 7.
`private static double` | `E2_08` Second error weights array, element 8.
`private static double` | `E2_09` Second error weights array, element 9.
`private static double` | `E2_10` Second error weights array, element 10.
`private static double` | `E2_11` Second error weights array, element 11.
`private static double` | `E2_12` Second error weights array, element 12.
`private static java.lang.String` | `METHOD_NAME` Integrator method name.
`private static double[][]` | `STATIC_A` Internal weights Butcher array.
`private static double[]` | `STATIC_B` Propagation weights Butcher array.
`private static double[]` | `STATIC_C` Time steps Butcher array.

Fields inherited from class org.apache.commons.math.ode.nonstiff.AdaptiveStepsizeIntegrator
`scalAbsoluteTolerance, scalRelativeTolerance, vecAbsoluteTolerance, vecRelativeTolerance`

Fields inherited from class org.apache.commons.math.ode.AbstractIntegrator
`eventsHandlersManager, stepHandlers, stepSize, stepStart`

Constructor Summary
`DormandPrince853Integrator(double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)` Simple constructor.
`DormandPrince853Integrator(double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)` Simple constructor.

Method Summary
`protected double` | `estimateError(double[][] yDotK, double[] y0, double[] y1, double h)` Compute the error ratio.
`int` | `getOrder()` Get the order of the method.

Methods inherited from class org.apache.commons.math.ode.nonstiff.EmbeddedRungeKuttaIntegrator
`getMaxGrowth, getMinReduction, getSafety, integrate, setMaxGrowth, setMinReduction, setSafety`

Methods inherited from class org.apache.commons.math.ode.nonstiff.AdaptiveStepsizeIntegrator
`filterStep, getCurrentStepStart, getMaxStep, getMinStep, initializeStep, resetInternalState, sanityChecks, setInitialStepSize`

Methods inherited from class org.apache.commons.math.ode.AbstractIntegrator
`addEndTimeChecker, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCurrentSignedStepsize, getEvaluations, getEventHandlers, getMaxEvaluations, getName, getStepHandlers, requiresDenseOutput, resetEvaluations, setEquations, setMaxEvaluations`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### METHOD_NAME

    private static final java.lang.String METHOD_NAME

  Integrator method name.

  See Also:
    Constant Field Values

### STATIC_C

    private static final double[] STATIC_C

  Time steps Butcher array.

### STATIC_A

    private static final double[][] STATIC_A

  Internal weights Butcher array.

### STATIC_B

    private static final double[] STATIC_B

  Propagation weights Butcher array.

### E1_01

    private static final double E1_01

  First error weights array, element 1.

  See Also:
    Constant Field Values

### E1_06

    private static final double E1_06

  First error weights array, element 6.

  See Also:
    Constant Field Values

### E1_07

    private static final double E1_07

  First error weights array, element 7.

  See Also:
    Constant Field Values

### E1_08

    private static final double E1_08

  First error weights array, element 8.

  See Also:
    Constant Field Values

### E1_09

    private static final double E1_09

  First error weights array, element 9.

  See Also:
    Constant Field Values

### E1_10

    private static final double E1_10

  First error weights array, element 10.

  See Also:
    Constant Field Values

### E1_11

    private static final double E1_11

  First error weights array, element 11.

  See Also:
    Constant Field Values

### E1_12

    private static final double E1_12

  First error weights array, element 12.

  See Also:
    Constant Field Values

### E2_01

    private static final double E2_01

  Second error weights array, element 1.

  See Also:
    Constant Field Values

### E2_06

    private static final double E2_06

  Second error weights array, element 6.

  See Also:
    Constant Field Values

### E2_07

    private static final double E2_07

  Second error weights array, element 7.

  See Also:
    Constant Field Values

### E2_08

    private static final double E2_08

  Second error weights array, element 8.

  See Also:
    Constant Field Values

### E2_09

    private static final double E2_09

  Second error weights array, element 9.

  See Also:
    Constant Field Values

### E2_10

    private static final double E2_10

  Second error weights array, element 10.

  See Also:
    Constant Field Values

### E2_11

    private static final double E2_11

  Second error weights array, element 11.

  See Also:
    Constant Field Values

### E2_12

    private static final double E2_12

  Second error weights array, element 12.

  See Also:
    Constant Field Values

Constructor Detail

### DormandPrince853Integrator

    public DormandPrince853Integrator(double minStep,
                                      double maxStep,
                                      double scalAbsoluteTolerance,
                                      double scalRelativeTolerance)

  Simple constructor. Build an eighth order Dormand-Prince integrator with the given step bounds

  Parameters:
    `minStep` - minimal step (must be positive even for backward integration), the last step can be smaller than this
    `maxStep` - maximal step (must be positive even for backward integration)
    `scalAbsoluteTolerance` - allowed absolute error
    `scalRelativeTolerance` - allowed relative error

### DormandPrince853Integrator

    public DormandPrince853Integrator(double minStep,
                                      double maxStep,
                                      double[] vecAbsoluteTolerance,
                                      double[] vecRelativeTolerance)

  Simple constructor. Build an eighth order Dormand-Prince integrator with the given step bounds

  Parameters:
    `minStep` - minimal step (must be positive even for backward integration), the last step can be smaller than this
    `maxStep` - maximal step (must be positive even for backward integration)
    `vecAbsoluteTolerance` - allowed absolute error
    `vecRelativeTolerance` - allowed relative error

Method Detail

### getOrder

    public int getOrder()

  Get the order of the method.

  Specified by:
    `getOrder` in class `EmbeddedRungeKuttaIntegrator`
  Returns:
    order of the method

### estimateError

    protected double estimateError(double[][] yDotK,
                                   double[] y0,
                                   double[] y1,
                                   double h)

  Compute the error ratio.

  Specified by:
    `estimateError` in class `EmbeddedRungeKuttaIntegrator`
  Parameters:
    `yDotK` - derivatives computed during the first stages
    `y0` - estimate of the step at the start of the step
    `y1` - estimate of the step at the end of the step
    `h` - current step
  Returns:
    error ratio, greater than 1 if step should be rejected

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2003-2011 Apache Software Foundation